<?php

class CImg
{
	function getType($fname)
	{
		list($width,$height,$typeID) = getimagesize($fname);
	
		switch($typeID)
		{
			case IMAGETYPE_GIF: $type = 'gif'; break;
			case IMAGETYPE_JPEG: $type = 'jpeg'; break;
			case IMAGETYPE_PNG: $type = 'png'; break;
			case IMAGETYPE_BMP: $type = 'bmp'; break;
			case IMAGETYPE_WBMP: $type = 'wbmp'; break;
			case IMAGETYPE_XBM: $type = 'xbm'; break;
			default: $type = false; break;
		}
		
		return $type;
	}
	
	function makeCrop($input, $output, $dim = array(300,200), $fill = false)
	{
		list($width,$height,$typeID) = getimagesize($input);
		
		switch($typeID)
		{
			case IMAGETYPE_GIF: $type = 'gif'; break;
			case IMAGETYPE_JPEG: $type = 'jpeg'; break;
			case IMAGETYPE_PNG: $type = 'png'; break;
			case IMAGETYPE_BMP: $type = 'bmp'; break;
			case IMAGETYPE_WBMP: $type = 'wbmp'; break;
			case IMAGETYPE_XBM: $type = 'xbm'; break;
			default: $type = false; break;
		}
		
		if($type == false)
			return false;
			
		if($fill)
		{
			if($width > $dim[0] || $height > $dim[1])
			{
				$new_width = $width * ($dim[1] / $height);
				$new_height = $dim[1];
				if($new_width > $dim[0])
				{
					$new_width = $dim[0];
					$new_height = $height * ($dim[0] / $width);
				}
			}
			else
			{
				$new_width = $width;
				$new_height = $height;
			}
		}
		
		if(!function_exists('imagecreatefrom'.$type))
			return false;
		$in = call_user_func('imagecreatefrom'.$type,$input);
		
	
		
		$out = imagecreatetruecolor($new_width,$new_height);
		imagealphablending($out,true);
		if($fill)
		{
			$c_fill = imagecolorallocatealpha($out,$fill[0],$fill[1],$fill[2],$fill[3]);
			imagefill($out,0,0,$c_fill);
		}
		imagecopyresampled($out, $in, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
		
		imagedestroy($in);
		
		$final = imagecreatetruecolor($dim[0],$dim[1]);
		
		if($fill)
		{
			$c_fill = imagecolorallocatealpha($final,$fill[0],$fill[1],$fill[2],$fill[3]);
			
			imagefill($final,0,0,$c_fill);
		}
		
		imagecopy($final,$out,floor(($dim[0]-$new_width)/2),floor(($dim[1]-$new_height)/2),0,0,$new_width,$new_height);

		call_user_func('image'.$type, $final,$output);
		
		imagedestroy($out);
		imagedestroy($final);
	}
	
	function makeThumb($imgName, $max = 150, $input = false, $output = false, $preserve = false, $data = false)
	{
		if($data)
		{
			$in = imagecreatefromstring($data);
			$width = imagesx($in);
			$height = imagesy($in);
			$type = 'jpeg';
		}
		else
		{
			$in = false;
			if($input)
				$fileName = $input;
			else
				$fileName = "uploads/{$imgName}";
			list($width,$height,$typeID) = getimagesize($fileName);
		
			switch($typeID)
			{
				case IMAGETYPE_GIF: $type = 'gif'; break;
				case IMAGETYPE_JPEG: $type = 'jpeg'; break;
				case IMAGETYPE_PNG: $type = 'png'; break;
				case IMAGETYPE_BMP: $type = 'bmp'; break;
				case IMAGETYPE_WBMP: $type = 'wbmp'; break;
				case IMAGETYPE_XBM: $type = 'xbm'; break;
				default: $type = false; break;
			}
		}
		
		if($type == false)
			return false;

		if(is_array($max))
		{
			if($width > $max[0] || $height > $max[1])
			{
				$new_width = $width * ($max[1] / $height);
				$new_height = $max[1];
				if($new_width > $max[0])
				{
					$new_width = $max[0];
					$new_height = $height * ($max[0] / $width);
				}
			}
			else
			{
				$new_width = $width;
				$new_height = $height;
			}
		}
		else
		{
			if($width > $max || $height > $max)
			{
				$new_width = $width * ($max / $height);
				$new_height = $max;
				if($new_width > $max)
				{
					$new_width = $max;
					$new_height = $height * ($max / $width);
				}
			}
			else
			{
				$new_width = $width;
				$new_height = $height;
			}
		}

		if(!$in)
		{
			if(!function_exists('imagecreatefrom'.$type))
				return false;
			$in = call_user_func('imagecreatefrom'.$type,$fileName);
		}

		$out = imagecreatetruecolor($new_width,$new_height);
		imagecopyresampled($out, $in, 0, 0, 0, 0, $new_width, $new_height, $width, $height);
		
		if($output)
		{
			if($preserve)
				call_user_func('image'.$type, $out, $output);
			else
				imagepng($out,$output);
		}
		else
		{
			if($preserve)
				call_user_func('image'.$type, $out, "thumbs/{$imgName}");
			else
				imagepng($out,"thumbs/{$imgName}");
		}
		
		imagedestroy($in);
		imagedestroy($out);
		return true;
	}
}

return false;
?>