<?php
/*
	QMC (Quick Mini Core) by Alessandro Ubriaco
	http://core.seedfuse.com/
*/

if(!defined('CORE'))
	exit(0);
define('MINI_CORE',1);
include_once 'etc/config.php';
include_once 'mdb.php';
include_once 'mlang.php';
include_once 'mlayout.php';

class MCore
{
	var $V = array();
	var $R = false;
	var $DB = false;
	var $Layout = false;
	var $Lang = false;
	var $SID = '';
	
	function init()
	{
		global $Conf;
		$this->DB = new MDB();
		$this->Lang = new MLang($Conf['language']);
		$this->Layout = new MLayout($Conf['template']);
		$this->Layout->Lang = $this->Lang;
		$this->DB->open();
		if(isset($_POST['_sid']))
			@session_id($_POST['_sid']);
		session_start();
		$this->SID = session_id();
		if(!defined('JOB'))
			$this->runFunc();
	}
	
	function runFunc()
	{
		$Core = $this;
		$dir = 'func';
		$handle = opendir($dir);
		while($fn = readdir($handle))
		{
			if(!is_dir($dir.'/'.$fn))
				include_once($dir.'/'.$fn);
		}
		closedir($handle);
	}
	
	function checkLogin()
	{
		if(isset($this->V['user']))
			return true;
		if(isset($_SESSION['mc_user']) && isset($_SESSION['mc_pass']))
		{
			$rs = $this->DB->query('SELECT * FROM users WHERE username=\''.$this->DB->esc(strtolower($_SESSION['mc_user'])).'\' AND password=\''.$this->DB->esc($_SESSION['mc_pass']).'\' LIMIT 1');
			if($rs->rowCount() > 0)
			{
				$this->V['user'] = $rs->getAssoc();
				return true;
			}
		}
		return false;
	}
	
	function isFlags($flags)
	{
		if(!isset($this->V['user']))
			return false;
		for($n = 0;$n < strlen($flags);$n++)
		{
			if(strpos($this->V['user']['flags'],$flags[$n]) !== false)
				return true;
		}
		return false;
	}
	
	function redirect($url)
	{
		header('Location: '.$url);
		exit(0);
	}
	
	function cs()
	{
		return ($_GET['sid'] == $this->SID);
	}
	
	function end()
	{
		$this->DB->close();
		exit(0);
	}
}

$Core = new MCore();
$Core->init();

?>