/*
	XH by Alessandro Ubriaco
	from FMCU
*/

var XH =
{
	xh : null,
	xhEvent : null,
	xhTarget : null,
	
	create : function()
	{
		var objXMLHttp = null;
		try
		{
			objXMLHttp=new XMLHttpRequest();
		}
		catch(e)
		{
			try
			{
				objXMLHttp=new ActiveXObject("Msxml2.XMLHTTP");
			}
			catch(e)
			{
				try
				{
					objXMLHttp=new ActiveXObject("Microsoft.XMLHTTP");
				}
				catch(e)
				{
					return false;	
				}
			}
		}
		return objXMLHttp;
	},
	
	supported : function()
	{
		if(!window.XMLHttpRequest && !window.ActiveXObject)
			return false;
		else
			return true;
	},
	
	stateChanged : function()
	{
		if(XH.xh.readyState == 4 || XH.xh.readyState == 'complete')
		{
			if(XH.Event == 'load' && XH.Target)
				document.getElementById(XH.Target).innerHTML = XH.xh.responseText;
		}
	},
	
	init : function()
	{
		XH.xh = XH.create();
		if(!XH.xh) return false;
		XH.xh.onreadystatechange = XH.stateChanged;
		return true;
	},
	
	loadTo : function(targetID,openURL,method)
	{
		if(!method)
			method = "GET";
		XH.Event = "load";
		XH.Target = targetID;
		XH.xh.open(method,openURL,true);
		XH.xh.send(null);
	},
	
	loadToEx : function(targetID,openURL,method,data)
	{
		if(!method)
			method = "GET";
		XH.Event = "load";
		XH.Target = targetID;
		XH.xh.open(method,openURL,true);
		XH.xh.send(data);
	},
	
	load : function(openURL,method)
	{
		XH.Event = "load";
		XH.Target = false;
		XH.xh.open(method,openURL,true);
		XH.xh.send(null);	
	},
	
	loadEx : function(openURL,method,data)
	{
		if(!method)
			method = "GET";
		XH.Event = "load";
		XH.Target = false;
		XH.xh.open(method,openURL,true);
		XH.xh.send(data);
	},
	
	buildPostData : function(arr)
	{
		var data = '';
		for(var n = 0; n < arr.length; n++)
		{
			if(data.length > 0)
				data += '&';
			data = arr[n] + '=' + document.getElementById(arr[n]).value;
		}
		return data;
	},
	
	filterParam : function(str)
	{
		str = str.replace(/&/g, '{AMP}');
		str = str.replace(/=/g, '{EQ}');
		return str;
	},
	
	makeUrlFriendly : function(str)
	{
		return this.filterParam(str);
	}
	
};

function CXH()
{
	var objXMLHttp = null;
	try
	{
		objXMLHttp=new XMLHttpRequest();
	}
	catch(e)
	{
		try
		{
			objXMLHttp=new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch(e)
		{
			try
			{
				objXMLHttp=new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch(e)
			{
				objXMLHttp = null;
			}
		}
	}
	this.XH = objXMLHttp;
	this.Target = null;
}

CXH.prototype.reinit = function()
{
	var objXMLHttp = null;
	try
	{
		objXMLHttp=new XMLHttpRequest();
	}
	catch(e)
	{
		try
		{
			objXMLHttp=new ActiveXObject("Msxml2.XMLHTTP");
		}
		catch(e)
		{
			try
			{
				objXMLHttp=new ActiveXObject("Microsoft.XMLHTTP");
			}
			catch(e)
			{
				objXMLHttp = null;
			}
		}
	}
	this.XH = objXMLHttp;
}

CXH.prototype.load = function(openUrl, method)
{
	if(this.XH != null)
	{
		this.XH.open(method, openUrl, true);
		this.XH.send(null);
	}
}

CXH.prototype.post = function(openUrl, data)
{
	if(this.XH != null)
	{
		this.XH.open('POST', openUrl, true);
		this.XH.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		this.XH.setRequestHeader("Content-length", data.length);
		this.XH.setRequestHeader("Connection", "close");
		this.XH.send(data);
	}
}

CXH.prototype.callback = function()
{
	if(this.XH.readyState == 4 || this.XH.readyState == 'complete')
	{
		var obj = document.getElementById(this.Target);
		if(obj)
			obj.innerHTML = this.XH.responseText;
	}
}

CXH.prototype.loadTo = function(targetId, openUrl, method)
{
	this.Target = targetId;
	this.setCallback(this.callback);
	this.load(openUrl, method);
}

CXH.prototype.setCallback = function(callback)
{
	if(this.XH != null)
		this.XH.onreadystatechange = callback;
}

